<?php

@session_start();

// Static internationalization

if(isset($_SESSION['lang']) || $_COOKIE['language'])
{
    if($_SESSION['lang'] == "Hungarian" || $_COOKIE['language'] == "Hungarian")
    {
	$langid = 1;
    }
    else
    {
	$langid = 0;
    }
}
else
{
    $langid = -1;
}

/*
 * Used languages:
 * -1 General, both
 *  0 English
 *  1 Hungarian
*/

$error[-1] = "Error";
$error[0] = "Error";
$error[1] = "Hiba";

if($fatal_error == "DB_ERROR")
{
    $errormsg[0] = "Database error.<br>Sorry, this page is now unavailable.";
    $errormsg[1] = "Adatbázis hiba.<br>Sajnos az oldal most nem érhető el.";
}
else
{
    $errormsg[0] = "Sorry, this page is now unavailable.";
    $errormsg[1] = "Sajnos az oldal most nem érhető el.";
}

    $errormsg[-1] = $errormsg[0] . '<br>' . $errormsg[1];

echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>';
echo $error[$langid] . '</title>
<style type="text/css">
html, body
{
    width: 100%;
    height: 100%;
    padding: 0px;
    margin: 0px;
    border: 0px;
}
</style>
</head>
<body>
';

print "<table width=\"100%\" height=\"100%\">\n";
print "<tr><td valign=\"middle\" align=\"center\">\n";
print "<div style=\"font-size:xx-large;\">\n";
print $errormsg[$langid] . "<br>\n";
print "</div>\n";
print "</td></tr>\n";
print "</table>\n";

echo '</body>
</html>
';

?>
