<?php
session_start();
require_once '../includes/sql.php';
require_once '../includes/session.php';
require_once '../includes/config.php';
require_once '../includes/text.php'; // copyinfo()
?>
<html>
<head>
<!--
In Microsoft Internet Explorer 6, the background images are flickering when
we do mouseover. The solution of this problem is by modifiing the .htaccess
file and the httpd.conf file. The method can be read here:

http://dean.edwards.name/my/flicker.html

(Another solutions can be possible, if we read the internet.)

-->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>WebMathematics Interactive 2</title>
<link rel="shortcut icon" type="image/x-icon" href="icon/wmi2_shortcut2.png">
<link rel="stylesheet" type="text/css" href="css/users1.css">
<link rel="stylesheet" type="text/css" href="css/calc1.css">
<!--[if IE]>
<link rel="stylesheet" type="text/css" href="css/ie1.css">
<![endif]-->
<script type="text/javascript" src="js/ajax.js"></script>
<script type="text/javascript" src="js/wmiutils.js"></script>
<script type="text/javascript" src="js/calc.js"></script>
<script type="text/javascript" src="js/ASCIIMathML.js"></script>
</head>
<body onload="loadFirst('equation','normal');"><div id="hidden" style="display:none;"></div>
<?php
// Browser detection
if (!isset($_COOKIE["browserchecked"])) // If browser not yet checked
{

    $errormsg = getmessage("errorbrowser", $_SESSION['lang']);
    // If there is no User-Agent string, JS will deal with it
    if (!isset($_SERVER['HTTP_USER_AGENT']) || $_SERVER['HTTP_USER_AGENT'] == "")
    {
	echo '<script type="text/javascript">';
	echo 'var errormsg = "';
	echo $errormsg;
	echo '";';
	echo '
if (navigator.appName.indexOf("Microsoft Internet Explorer") != -1)
{

    temp = navigator.appVersion.split("MSIE");
    version = parseFloat(temp[1]);
    if (version < 6.0)
    {

	alert(errormsg);

    }

}
else if (navigator.appName.indexOf("Netscape") != -1)
{
    if(parseFloat(navigator.appVersion) < 5.0)
    {

      alert(errormsg);

    }

}
else
{

    alert(errormsg);

}
</script>
';

    }
    else if(strpos($_SERVER['HTTP_USER_AGENT'], "Firefox/2") === false &&
	   strpos($_SERVER['HTTP_USER_AGENT'], "Iceweasel/2") === false &&
	   strpos($_SERVER['HTTP_USER_AGENT'], "Firefox/3") === false &&
	   strpos($_SERVER['HTTP_USER_AGENT'], "Iceweasel/3") === false &&
	   strpos($_SERVER['HTTP_USER_AGENT'], " Chrome/") === false &&
	   strpos($_SERVER['HTTP_USER_AGENT'], "MSIE 6") === false &&
	   strpos($_SERVER['HTTP_USER_AGENT'], "MSIE 7") === false)
    {
	echo "<script type=\"text/javascript\">\n";
	echo "alert(\"$errormsg\");\n";
	echo "</script>\n";
    }

    echo "<script type=\"text/javascript\">\n";
    echo "document.cookie = 'browserchecked=true; expires=Fri, 1 Jan 2010 20:00:00 UTC; path=/';\n";
    echo "</script>\n";
}
?><div id="content" class="content"><div id="workspace2" class="workspace2"><div id="workspace1" class="workspace1"><div id="workspace" class="workspace"><div id="wtop"></div></div></div></div></div><div id="worksheetops" class="worksheetops"><a onclick="newWorksheet()" style="cursor:pointer;">
<?php
print '<img src="icon/stock_new.';
print $imgext;
print '" title="';
$tmp = getmessage("ws_newhint", $_SESSION['lang']);
print "$tmp\" alt=\"$tmp\"></a>";
print '<a onclick="saveWorksheet()" style="cursor:pointer;"><img src="icon/stock_save.';
print $imgext;
print '" title="';
$tmp = getmessage("ws_savehint", $_SESSION['lang']);
print "$tmp\" alt=\"$tmp\"></a>";
print '<a onclick="printWorksheet()" style="cursor:pointer;"><img src="icon/stock_print-preview.';
print $imgext;
print '" title="';
$tmp = getmessage("ws_printhint", $_SESSION['lang']);
print "$tmp\" alt=\"$tmp\"></a>";

if ($developers_on == TRUE) {
print "<a onclick=\"window.open('../wekker/index.php','For developers')\" style=\"cursor:pointer;\"><img src=\"icon/gnome-control-center.";
print $imgext;
print "\" title=\"";
$tmp = getmessage("ws_devhint", $_SESSION['lang']);
print "$tmp\" alt=\"$tmp\"></a>\n";
}
?>
<a onclick="window.open('info.php','Informations','width=340px, height=700px, scollbars=yes')" style="cursor:pointer;border:0px"><img src="icon/stock_book_green.png" style="border:0px;"
title="<?php
$tmp = getmessage("ws_helphint", $_SESSION['lang']);
print "$tmp\" alt=\"$tmp\"> </a>\n";

function paypal()
{
 echo '
 <form action="https://www.paypal.com/cgi-bin/webscr" method="post" style="display:inline;">
 <input type="hidden" name="cmd" value="_xclick">
 <input type="hidden" name="business" value="kovzol@gmail.com">
 <input type="hidden" name="item_name" value="WebMathematics Interactive">
 <input type="hidden" name="amount" value="5.00">
 <input type="hidden" name="buyer_credit_promo_code" value="">
 <input type="hidden" name="buyer_credit_product_category" value="">
 <input type="hidden" name="buyer_credit_shipping_method" value="">
 <input type="hidden" name="buyer_credit_user_address_change" value="">
 <input type="hidden" name="no_shipping" value="1">
 <input type="hidden" name="cn" value="Your comment to the developers">
 <input type="hidden" name="currency_code" value="EUR">
 <input type="hidden" name="tax" value="0">
 <input type="hidden" name="lc" value="HU">
 <input type="hidden" name="bn" value="PP-DonationsBF">
 <input type="image" src="./icon/paypal.gif" title="';
echo getmessage("ws_paypal",$_SESSION['lang']);
echo '" style="border:0px" name="submit" alt="Make payments with PayPal - it\'s fast, free and secure!">
 </form>';
}
paypal();
?></div><div id="fixdiv" class="fixdiv">
<div id="topleft">
<div id="titletext"><a onclick="setwmibear(true,null,true)"><?php
print $homepage_title;
?></a></div>
</div>
<div id="calcdiv" class="calcdiv"></div>
<div id="copyright" class="copyright" 
onclick="window.open('info.php','Informations','width=340px, height=700px, scrollbars=yes')"><?php
copyinfo($_SESSION['lang'], 9);
?></div></div></body>
</html>
