dnl aclocal.m4 generated automatically by aclocal 1.4-p6

dnl Copyright (C) 1994, 1995-8, 1999, 2001 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

# lib-prefix.m4 serial 4 (gettext-0.14.2)
dnl Copyright (C) 2001-2005 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl From Bruno Haible.

dnl AC_LIB_ARG_WITH is synonymous to AC_ARG_WITH in autoconf-2.13, and
dnl similar to AC_ARG_WITH in autoconf 2.52...2.57 except that is doesn't
dnl require excessive bracketing.
ifdef([AC_HELP_STRING],
[AC_DEFUN([AC_LIB_ARG_WITH], [AC_ARG_WITH([$1],[[$2]],[$3],[$4])])],
[AC_DEFUN([AC_][LIB_ARG_WITH], [AC_ARG_WITH([$1],[$2],[$3],[$4])])])

dnl AC_LIB_PREFIX adds to the CPPFLAGS and LDFLAGS the flags that are needed
dnl to access previously installed libraries. The basic assumption is that
dnl a user will want packages to use other packages he previously installed
dnl with the same --prefix option.
dnl This macro is not needed if only AC_LIB_LINKFLAGS is used to locate
dnl libraries, but is otherwise very convenient.
AC_DEFUN([AC_LIB_PREFIX],
[
  AC_BEFORE([$0], [AC_LIB_LINKFLAGS])
  AC_REQUIRE([AC_PROG_CC])
  AC_REQUIRE([AC_CANONICAL_HOST])
  AC_REQUIRE([AC_LIB_PREPARE_PREFIX])
  dnl By default, look in $includedir and $libdir.
  use_additional=yes
  AC_LIB_WITH_FINAL_PREFIX([
    eval additional_includedir=\"$includedir\"
    eval additional_libdir=\"$libdir\"
  ])
  AC_LIB_ARG_WITH([lib-prefix],
[  --with-lib-prefix[=DIR] search for libraries in DIR/include and DIR/lib
  --without-lib-prefix    don't search for libraries in includedir and libdir],
[
    if test "X$withval" = "Xno"; then
      use_additional=no
    else
      if test "X$withval" = "X"; then
        AC_LIB_WITH_FINAL_PREFIX([
          eval additional_includedir=\"$includedir\"
          eval additional_libdir=\"$libdir\"
        ])
      else
        additional_includedir="$withval/include"
        additional_libdir="$withval/lib"
      fi
    fi
])
  if test $use_additional = yes; then
    dnl Potentially add $additional_includedir to $CPPFLAGS.
    dnl But don't add it
    dnl   1. if it's the standard /usr/include,
    dnl   2. if it's already present in $CPPFLAGS,
    dnl   3. if it's /usr/local/include and we are using GCC on Linux,
    dnl   4. if it doesn't exist as a directory.
    if test "X$additional_includedir" != "X/usr/include"; then
      haveit=
      for x in $CPPFLAGS; do
        AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
        if test "X$x" = "X-I$additional_includedir"; then
          haveit=yes
          break
        fi
      done
      if test -z "$haveit"; then
        if test "X$additional_includedir" = "X/usr/local/include"; then
          if test -n "$GCC"; then
            case $host_os in
              linux* | gnu* | k*bsd*-gnu) haveit=yes;;
            esac
          fi
        fi
        if test -z "$haveit"; then
          if test -d "$additional_includedir"; then
            dnl Really add $additional_includedir to $CPPFLAGS.
            CPPFLAGS="${CPPFLAGS}${CPPFLAGS:+ }-I$additional_includedir"
          fi
        fi
      fi
    fi
    dnl Potentially add $additional_libdir to $LDFLAGS.
    dnl But don't add it
    dnl   1. if it's the standard /usr/lib,
    dnl   2. if it's already present in $LDFLAGS,
    dnl   3. if it's /usr/local/lib and we are using GCC on Linux,
    dnl   4. if it doesn't exist as a directory.
    if test "X$additional_libdir" != "X/usr/lib"; then
      haveit=
      for x in $LDFLAGS; do
        AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
        if test "X$x" = "X-L$additional_libdir"; then
          haveit=yes
          break
        fi
      done
      if test -z "$haveit"; then
        if test "X$additional_libdir" = "X/usr/local/lib"; then
          if test -n "$GCC"; then
            case $host_os in
              linux*) haveit=yes;;
            esac
          fi
        fi
        if test -z "$haveit"; then
          if test -d "$additional_libdir"; then
            dnl Really add $additional_libdir to $LDFLAGS.
            LDFLAGS="${LDFLAGS}${LDFLAGS:+ }-L$additional_libdir"
          fi
        fi
      fi
    fi
  fi
])

dnl AC_LIB_PREPARE_PREFIX creates variables acl_final_prefix,
dnl acl_final_exec_prefix, containing the values to which $prefix and
dnl $exec_prefix will expand at the end of the configure script.
AC_DEFUN([AC_LIB_PREPARE_PREFIX],
[
  dnl Unfortunately, prefix and exec_prefix get only finally determined
  dnl at the end of configure.
  if test "X$prefix" = "XNONE"; then
    acl_final_prefix="$ac_default_prefix"
  else
    acl_final_prefix="$prefix"
  fi
  if test "X$exec_prefix" = "XNONE"; then
    acl_final_exec_prefix='${prefix}'
  else
    acl_final_exec_prefix="$exec_prefix"
  fi
  acl_save_prefix="$prefix"
  prefix="$acl_final_prefix"
  eval acl_final_exec_prefix=\"$acl_final_exec_prefix\"
  prefix="$acl_save_prefix"
])

dnl AC_LIB_WITH_FINAL_PREFIX([statement]) evaluates statement, with the
dnl variables prefix and exec_prefix bound to the values they will have
dnl at the end of the configure script.
AC_DEFUN([AC_LIB_WITH_FINAL_PREFIX],
[
  acl_save_prefix="$prefix"
  prefix="$acl_final_prefix"
  acl_save_exec_prefix="$exec_prefix"
  exec_prefix="$acl_final_exec_prefix"
  $1
  exec_prefix="$acl_save_exec_prefix"
  prefix="$acl_save_prefix"
])

# lib-prefix.m4 serial 1 (gettext-0.11)
dnl Copyright (C) 2001-2002 Free Software Foundation, Inc.
dnl This file is free software, distributed under the terms of the GNU
dnl General Public License.  As a special exception to the GNU General
dnl Public License, this file may be distributed as part of a program
dnl that contains a configuration script generated by Autoconf, under
dnl the same distribution terms as the rest of that program.

dnl From Bruno Haible.

dnl AC_LIB_PREFIX adds to the CPPFLAGS and LDFLAGS the flags that are needed
dnl to access previously installed libraries. The basic assumption is that
dnl a user will want packages to use other packages he previously installed
dnl with the same --prefix option.
dnl This macro is not needed if only AC_LIB_LINKFLAGS is used to locate
dnl libraries, but is otherwise very convenient.
AC_DEFUN([AC_LIB_PREFIX],
[
  AC_BEFORE([$0], [AC_LIB_LINKFLAGS])
  AC_REQUIRE([AC_PROG_CC])
  AC_REQUIRE([AC_CANONICAL_HOST])
  AC_REQUIRE([AC_LIB_PREPARE_PREFIX])
  dnl By default, look in $includedir and $libdir.
  use_additional=yes
  AC_LIB_WITH_FINAL_PREFIX([
    eval additional_includedir=\"$includedir\"
    eval additional_libdir=\"$libdir\"
  ])
  AC_ARG_WITH([lib-prefix],
[  --with-lib-prefix[=DIR] search for libraries in DIR/include and DIR/lib
  --without-lib-prefix    don't search for libraries in includedir and libdir],
[
    if test "X$withval" = "Xno"; then
      use_additional=no
    else
      if test "X$withval" = "X"; then
        AC_LIB_WITH_FINAL_PREFIX([
          eval additional_includedir=\"$includedir\"
          eval additional_libdir=\"$libdir\"
        ])
      else
        additional_includedir="$withval/include"
        additional_libdir="$withval/lib"
      fi
    fi
])
  if test $use_additional = yes; then
    dnl Potentially add $additional_includedir to $CPPFLAGS.
    dnl But don't add it
    dnl   1. if it's the standard /usr/include,
    dnl   2. if it's already present in $CPPFLAGS,
    dnl   3. if it's /usr/local/include and we are using GCC on Linux,
    dnl   4. if it doesn't exist as a directory.
    if test "X$additional_includedir" != "X/usr/include"; then
      haveit=
      for x in $CPPFLAGS; do
        AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
        if test "X$x" = "X-I$additional_includedir"; then
          haveit=yes
          break
        fi
      done
      if test -z "$haveit"; then
        if test "X$additional_includedir" = "X/usr/local/include"; then
          if test -n "$GCC"; then
            case $host_os in
              linux*) haveit=yes;;
            esac
          fi
        fi
        if test -z "$haveit"; then
          if test -d "$additional_includedir"; then
            dnl Really add $additional_includedir to $CPPFLAGS.
            CPPFLAGS="${CPPFLAGS}${CPPFLAGS:+ }-I$additional_includedir"
          fi
        fi
      fi
    fi
    dnl Potentially add $additional_libdir to $LDFLAGS.
    dnl But don't add it
    dnl   1. if it's the standard /usr/lib,
    dnl   2. if it's already present in $LDFLAGS,
    dnl   3. if it's /usr/local/lib and we are using GCC on Linux,
    dnl   4. if it doesn't exist as a directory.
    if test "X$additional_libdir" != "X/usr/lib"; then
      haveit=
      for x in $LDFLAGS; do
        AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
        if test "X$x" = "X-L$additional_libdir"; then
          haveit=yes
          break
        fi
      done
      if test -z "$haveit"; then
        if test "X$additional_libdir" = "X/usr/local/lib"; then
          if test -n "$GCC"; then
            case $host_os in
              linux*) haveit=yes;;
            esac
          fi
        fi
        if test -z "$haveit"; then
          if test -d "$additional_libdir"; then
            dnl Really add $additional_libdir to $LDFLAGS.
            LDFLAGS="${LDFLAGS}${LDFLAGS:+ }-L$additional_libdir"
          fi
        fi
      fi
    fi
  fi
])

dnl AC_LIB_PREPARE_PREFIX creates variables acl_final_prefix,
dnl acl_final_exec_prefix, containing the values to which $prefix and
dnl $exec_prefix will expand at the end of the configure script.
AC_DEFUN([AC_LIB_PREPARE_PREFIX],
[
  dnl Unfortunately, prefix and exec_prefix get only finally determined
  dnl at the end of configure.
  if test "X$prefix" = "XNONE"; then
    acl_final_prefix="$ac_default_prefix"
  else
    acl_final_prefix="$prefix"
  fi
  if test "X$exec_prefix" = "XNONE"; then
    acl_final_exec_prefix='${prefix}'
  else
    acl_final_exec_prefix="$exec_prefix"
  fi
  acl_save_prefix="$prefix"
  prefix="$acl_final_prefix"
  eval acl_final_exec_prefix=\"$acl_final_exec_prefix\"
  prefix="$acl_save_prefix"
])

dnl AC_LIB_WITH_FINAL_PREFIX([statement]) evaluates statement, with the
dnl variables prefix and exec_prefix bound to the values they will have
dnl at the end of the configure script.
AC_DEFUN([AC_LIB_WITH_FINAL_PREFIX],
[
  acl_save_prefix="$prefix"
  prefix="$acl_final_prefix"
  acl_save_exec_prefix="$exec_prefix"
  exec_prefix="$acl_final_exec_prefix"
  $1
  exec_prefix="$acl_save_exec_prefix"
  prefix="$acl_save_prefix"
])

# lib-link.m4 serial 3 (gettext-0.11.3)
dnl Copyright (C) 2001-2002 Free Software Foundation, Inc.
dnl This file is free software, distributed under the terms of the GNU
dnl General Public License.  As a special exception to the GNU General
dnl Public License, this file may be distributed as part of a program
dnl that contains a configuration script generated by Autoconf, under
dnl the same distribution terms as the rest of that program.

dnl From Bruno Haible.

dnl AC_LIB_LINKFLAGS(name [, dependencies]) searches for libname and
dnl the libraries corresponding to explicit and implicit dependencies.
dnl Sets and AC_SUBSTs the LIB${NAME} and LTLIB${NAME} variables and
dnl augments the CPPFLAGS variable.
AC_DEFUN([AC_LIB_LINKFLAGS],
[
  AC_REQUIRE([AC_LIB_PREPARE_PREFIX])
  AC_REQUIRE([AC_LIB_RPATH])
  define([Name],[translit([$1],[./-], [___])])
  define([NAME],[translit([$1],[abcdefghijklmnopqrstuvwxyz./-],
                               [ABCDEFGHIJKLMNOPQRSTUVWXYZ___])])
  AC_CACHE_CHECK([how to link with lib[]$1], [ac_cv_lib[]Name[]_libs], [
    AC_LIB_LINKFLAGS_BODY([$1], [$2])
    ac_cv_lib[]Name[]_libs="$LIB[]NAME"
    ac_cv_lib[]Name[]_ltlibs="$LTLIB[]NAME"
    ac_cv_lib[]Name[]_cppflags="$INC[]NAME"
  ])
  LIB[]NAME="$ac_cv_lib[]Name[]_libs"
  LTLIB[]NAME="$ac_cv_lib[]Name[]_ltlibs"
  INC[]NAME="$ac_cv_lib[]Name[]_cppflags"
  AC_LIB_APPENDTOVAR([CPPFLAGS], [$INC]NAME)
  AC_SUBST([LIB]NAME)
  AC_SUBST([LTLIB]NAME)
  dnl Also set HAVE_LIB[]NAME so that AC_LIB_HAVE_LINKFLAGS can reuse the
  dnl results of this search when this library appears as a dependency.
  HAVE_LIB[]NAME=yes
  undefine([Name])
  undefine([NAME])
])

dnl AC_LIB_HAVE_LINKFLAGS(name, dependencies, includes, testcode)
dnl searches for libname and the libraries corresponding to explicit and
dnl implicit dependencies, together with the specified include files and
dnl the ability to compile and link the specified testcode. If found, it
dnl sets and AC_SUBSTs HAVE_LIB${NAME}=yes and the LIB${NAME} and
dnl LTLIB${NAME} variables and augments the CPPFLAGS variable, and
dnl #defines HAVE_LIB${NAME} to 1. Otherwise, it sets and AC_SUBSTs
dnl HAVE_LIB${NAME}=no and LIB${NAME} and LTLIB${NAME} to empty.
AC_DEFUN([AC_LIB_HAVE_LINKFLAGS],
[
  AC_REQUIRE([AC_LIB_PREPARE_PREFIX])
  AC_REQUIRE([AC_LIB_RPATH])
  define([Name],[translit([$1],[./-], [___])])
  define([NAME],[translit([$1],[abcdefghijklmnopqrstuvwxyz./-],
                               [ABCDEFGHIJKLMNOPQRSTUVWXYZ___])])

  dnl Search for lib[]Name and define LIB[]NAME, LTLIB[]NAME and INC[]NAME
  dnl accordingly.
  AC_LIB_LINKFLAGS_BODY([$1], [$2])

  dnl Add $INC[]NAME to CPPFLAGS before performing the following checks,
  dnl because if the user has installed lib[]Name and not disabled its use
  dnl via --without-lib[]Name-prefix, he wants to use it.
  ac_save_CPPFLAGS="$CPPFLAGS"
  AC_LIB_APPENDTOVAR([CPPFLAGS], [$INC]NAME)

  AC_CACHE_CHECK([for lib[]$1], [ac_cv_lib[]Name], [
    ac_save_LIBS="$LIBS"
    LIBS="$LIBS $LIB[]NAME"
    AC_TRY_LINK([$3], [$4], [ac_cv_lib[]Name=yes], [ac_cv_lib[]Name=no])
    LIBS="$ac_save_LIBS"
  ])
  if test "$ac_cv_lib[]Name" = yes; then
    HAVE_LIB[]NAME=yes
    AC_DEFINE([HAVE_LIB]NAME, 1, [Define if you have the $1 library.])
    AC_MSG_CHECKING([how to link with lib[]$1])
    AC_MSG_RESULT([$LIB[]NAME])
  else
    HAVE_LIB[]NAME=no
    dnl If $LIB[]NAME didn't lead to a usable library, we don't need
    dnl $INC[]NAME either.
    CPPFLAGS="$ac_save_CPPFLAGS"
    LIB[]NAME=
    LTLIB[]NAME=
  fi
  AC_SUBST([HAVE_LIB]NAME)
  AC_SUBST([LIB]NAME)
  AC_SUBST([LTLIB]NAME)
  undefine([Name])
  undefine([NAME])
])

dnl Determine the platform dependent parameters needed to use rpath:
dnl libext, shlibext, hardcode_libdir_flag_spec, hardcode_libdir_separator,
dnl hardcode_direct, hardcode_minus_L,
dnl sys_lib_search_path_spec, sys_lib_dlsearch_path_spec.
AC_DEFUN([AC_LIB_RPATH],
[
  AC_REQUIRE([AC_PROG_CC])                dnl we use $CC, $GCC, $LDFLAGS
  AC_REQUIRE([AC_LIB_PROG_LD])            dnl we use $LD, $with_gnu_ld
  AC_REQUIRE([AC_CANONICAL_HOST])         dnl we use $host
  AC_REQUIRE([AC_CONFIG_AUX_DIR_DEFAULT]) dnl we use $ac_aux_dir
  AC_CACHE_CHECK([for shared library run path origin], acl_cv_rpath, [
    CC="$CC" GCC="$GCC" LDFLAGS="$LDFLAGS" LD="$LD" with_gnu_ld="$with_gnu_ld" \
    ${CONFIG_SHELL-/bin/sh} "$ac_aux_dir/config.rpath" "$host" > conftest.sh
    . ./conftest.sh
    rm -f ./conftest.sh
    acl_cv_rpath=done
  ])
  wl="$acl_cv_wl"
  libext="$acl_cv_libext"
  shlibext="$acl_cv_shlibext"
  hardcode_libdir_flag_spec="$acl_cv_hardcode_libdir_flag_spec"
  hardcode_libdir_separator="$acl_cv_hardcode_libdir_separator"
  hardcode_direct="$acl_cv_hardcode_direct"
  hardcode_minus_L="$acl_cv_hardcode_minus_L"
  sys_lib_search_path_spec="$acl_cv_sys_lib_search_path_spec"
  sys_lib_dlsearch_path_spec="$acl_cv_sys_lib_dlsearch_path_spec"
  dnl Determine whether the user wants rpath handling at all.
  AC_ARG_ENABLE(rpath,
    [  --disable-rpath         do not hardcode runtime library paths],
    :, enable_rpath=yes)
])

dnl AC_LIB_LINKFLAGS_BODY(name [, dependencies]) searches for libname and
dnl the libraries corresponding to explicit and implicit dependencies.
dnl Sets the LIB${NAME}, LTLIB${NAME} and INC${NAME} variables.
AC_DEFUN([AC_LIB_LINKFLAGS_BODY],
[
  define([NAME],[translit([$1],[abcdefghijklmnopqrstuvwxyz./-],
                               [ABCDEFGHIJKLMNOPQRSTUVWXYZ___])])
  dnl By default, look in $includedir and $libdir.
  use_additional=yes
  AC_LIB_WITH_FINAL_PREFIX([
    eval additional_includedir=\"$includedir\"
    eval additional_libdir=\"$libdir\"
  ])
  AC_ARG_WITH([lib$1-prefix],
[  --with-lib$1-prefix[=DIR]  search for lib$1 in DIR/include and DIR/lib
  --without-lib$1-prefix     don't search for lib$1 in includedir and libdir],
[
    if test "X$withval" = "Xno"; then
      use_additional=no
    else
      if test "X$withval" = "X"; then
        AC_LIB_WITH_FINAL_PREFIX([
          eval additional_includedir=\"$includedir\"
          eval additional_libdir=\"$libdir\"
        ])
      else
        additional_includedir="$withval/include"
        additional_libdir="$withval/lib"
      fi
    fi
])
  dnl Search the library and its dependencies in $additional_libdir and
  dnl $LDFLAGS. Using breadth-first-seach.
  LIB[]NAME=
  LTLIB[]NAME=
  INC[]NAME=
  rpathdirs=
  ltrpathdirs=
  names_already_handled=
  names_next_round='$1 $2'
  while test -n "$names_next_round"; do
    names_this_round="$names_next_round"
    names_next_round=
    for name in $names_this_round; do
      already_handled=
      for n in $names_already_handled; do
        if test "$n" = "$name"; then
          already_handled=yes
          break
        fi
      done
      if test -z "$already_handled"; then
        names_already_handled="$names_already_handled $name"
        dnl See if it was already located by an earlier AC_LIB_LINKFLAGS
        dnl or AC_LIB_HAVE_LINKFLAGS call.
        uppername=`echo "$name" | sed -e 'y|abcdefghijklmnopqrstuvwxyz./-|ABCDEFGHIJKLMNOPQRSTUVWXYZ___|'`
        eval value=\"\$HAVE_LIB$uppername\"
        if test -n "$value"; then
          if test "$value" = yes; then
            eval value=\"\$LIB$uppername\"
            test -z "$value" || LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$value"
            eval value=\"\$LTLIB$uppername\"
            test -z "$value" || LTLIB[]NAME="${LTLIB[]NAME}${LTLIB[]NAME:+ }$value"
          else
            dnl An earlier call to AC_LIB_HAVE_LINKFLAGS has determined
            dnl that this library doesn't exist. So just drop it.
            :
          fi
        else
          dnl Search the library lib$name in $additional_libdir and $LDFLAGS
          dnl and the already constructed $LIBNAME/$LTLIBNAME.
          found_dir=
          found_la=
          found_so=
          found_a=
          if test $use_additional = yes; then
            if test -n "$shlibext" && test -f "$additional_libdir/lib$name.$shlibext"; then
              found_dir="$additional_libdir"
              found_so="$additional_libdir/lib$name.$shlibext"
              if test -f "$additional_libdir/lib$name.la"; then
                found_la="$additional_libdir/lib$name.la"
              fi
            else
              if test -f "$additional_libdir/lib$name.$libext"; then
                found_dir="$additional_libdir"
                found_a="$additional_libdir/lib$name.$libext"
                if test -f "$additional_libdir/lib$name.la"; then
                  found_la="$additional_libdir/lib$name.la"
                fi
              fi
            fi
          fi
          if test "X$found_dir" = "X"; then
            for x in $LDFLAGS $LTLIB[]NAME; do
              AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
              case "$x" in
                -L*)
                  dir=`echo "X$x" | sed -e 's/^X-L//'`
                  if test -n "$shlibext" && test -f "$dir/lib$name.$shlibext"; then
                    found_dir="$dir"
                    found_so="$dir/lib$name.$shlibext"
                    if test -f "$dir/lib$name.la"; then
                      found_la="$dir/lib$name.la"
                    fi
                  else
                    if test -f "$dir/lib$name.$libext"; then
                      found_dir="$dir"
                      found_a="$dir/lib$name.$libext"
                      if test -f "$dir/lib$name.la"; then
                        found_la="$dir/lib$name.la"
                      fi
                    fi
                  fi
                  ;;
              esac
              if test "X$found_dir" != "X"; then
                break
              fi
            done
          fi
          if test "X$found_dir" != "X"; then
            dnl Found the library.
            LTLIB[]NAME="${LTLIB[]NAME}${LTLIB[]NAME:+ }-L$found_dir -l$name"
            if test "X$found_so" != "X"; then
              dnl Linking with a shared library. We attempt to hardcode its
              dnl directory into the executable's runpath, unless it's the
              dnl standard /usr/lib.
              if test "$enable_rpath" = no || test "X$found_dir" = "X/usr/lib"; then
                dnl No hardcoding is needed.
                LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$found_so"
              else
                dnl Use an explicit option to hardcode DIR into the resulting
                dnl binary.
                dnl Potentially add DIR to ltrpathdirs.
                dnl The ltrpathdirs will be appended to $LTLIBNAME at the end.
                haveit=
                for x in $ltrpathdirs; do
                  if test "X$x" = "X$found_dir"; then
                    haveit=yes
                    break
                  fi
                done
                if test -z "$haveit"; then
                  ltrpathdirs="$ltrpathdirs $found_dir"
                fi
                dnl The hardcoding into $LIBNAME is system dependent.
                if test "$hardcode_direct" = yes; then
                  dnl Using DIR/libNAME.so during linking hardcodes DIR into the
                  dnl resulting binary.
                  LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$found_so"
                else
                  if test -n "$hardcode_libdir_flag_spec" && test "$hardcode_minus_L" = no; then
                    dnl Use an explicit option to hardcode DIR into the resulting
                    dnl binary.
                    LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$found_so"
                    dnl Potentially add DIR to rpathdirs.
                    dnl The rpathdirs will be appended to $LIBNAME at the end.
                    haveit=
                    for x in $rpathdirs; do
                      if test "X$x" = "X$found_dir"; then
                        haveit=yes
                        break
                      fi
                    done
                    if test -z "$haveit"; then
                      rpathdirs="$rpathdirs $found_dir"
                    fi
                  else
                    dnl Rely on "-L$found_dir".
                    dnl But don't add it if it's already contained in the LDFLAGS
                    dnl or the already constructed $LIBNAME
                    haveit=
                    for x in $LDFLAGS $LIB[]NAME; do
                      AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
                      if test "X$x" = "X-L$found_dir"; then
                        haveit=yes
                        break
                      fi
                    done
                    if test -z "$haveit"; then
                      LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }-L$found_dir"
                    fi
                    if test "$hardcode_minus_L" != no; then
                      dnl FIXME: Not sure whether we should use
                      dnl "-L$found_dir -l$name" or "-L$found_dir $found_so"
                      dnl here.
                      LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$found_so"
                    else
                      dnl We cannot use $hardcode_runpath_var and LD_RUN_PATH
                      dnl here, because this doesn't fit in flags passed to the
                      dnl compiler. So give up. No hardcoding. This affects only
                      dnl very old systems.
                      dnl FIXME: Not sure whether we should use
                      dnl "-L$found_dir -l$name" or "-L$found_dir $found_so"
                      dnl here.
                      LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }-l$name"
                    fi
                  fi
                fi
              fi
            else
              if test "X$found_a" != "X"; then
                dnl Linking with a static library.
                LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$found_a"
              else
                dnl We shouldn't come here, but anyway it's good to have a
                dnl fallback.
                LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }-L$found_dir -l$name"
              fi
            fi
            dnl Assume the include files are nearby.
            additional_includedir=
            case "$found_dir" in
              */lib | */lib/)
                basedir=`echo "X$found_dir" | sed -e 's,^X,,' -e 's,/lib/*$,,'`
                additional_includedir="$basedir/include"
                ;;
            esac
            if test "X$additional_includedir" != "X"; then
              dnl Potentially add $additional_includedir to $INCNAME.
              dnl But don't add it
              dnl   1. if it's the standard /usr/include,
              dnl   2. if it's /usr/local/include and we are using GCC on Linux,
              dnl   3. if it's already present in $CPPFLAGS or the already
              dnl      constructed $INCNAME,
              dnl   4. if it doesn't exist as a directory.
              if test "X$additional_includedir" != "X/usr/include"; then
                haveit=
                if test "X$additional_includedir" = "X/usr/local/include"; then
                  if test -n "$GCC"; then
                    case $host_os in
                      linux*) haveit=yes;;
                    esac
                  fi
                fi
                if test -z "$haveit"; then
                  for x in $CPPFLAGS $INC[]NAME; do
                    AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
                    if test "X$x" = "X-I$additional_includedir"; then
                      haveit=yes
                      break
                    fi
                  done
                  if test -z "$haveit"; then
                    if test -d "$additional_includedir"; then
                      dnl Really add $additional_includedir to $INCNAME.
                      INC[]NAME="${INC[]NAME}${INC[]NAME:+ }-I$additional_includedir"
                    fi
                  fi
                fi
              fi
            fi
            dnl Look for dependencies.
            if test -n "$found_la"; then
              dnl Read the .la file. It defines the variables
              dnl dlname, library_names, old_library, dependency_libs, current,
              dnl age, revision, installed, dlopen, dlpreopen, libdir.
              save_libdir="$libdir"
              case "$found_la" in
                */* | *\\*) . "$found_la" ;;
                *) . "./$found_la" ;;
              esac
              libdir="$save_libdir"
              dnl We use only dependency_libs.
              for dep in $dependency_libs; do
                case "$dep" in
                  -L*)
                    additional_libdir=`echo "X$dep" | sed -e 's/^X-L//'`
                    dnl Potentially add $additional_libdir to $LIBNAME and $LTLIBNAME.
                    dnl But don't add it
                    dnl   1. if it's the standard /usr/lib,
                    dnl   2. if it's /usr/local/lib and we are using GCC on Linux,
                    dnl   3. if it's already present in $LDFLAGS or the already
                    dnl      constructed $LIBNAME,
                    dnl   4. if it doesn't exist as a directory.
                    if test "X$additional_libdir" != "X/usr/lib"; then
                      haveit=
                      if test "X$additional_libdir" = "X/usr/local/lib"; then
                        if test -n "$GCC"; then
                          case $host_os in
                            linux*) haveit=yes;;
                          esac
                        fi
                      fi
                      if test -z "$haveit"; then
                        haveit=
                        for x in $LDFLAGS $LIB[]NAME; do
                          AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
                          if test "X$x" = "X-L$additional_libdir"; then
                            haveit=yes
                            break
                          fi
                        done
                        if test -z "$haveit"; then
                          if test -d "$additional_libdir"; then
                            dnl Really add $additional_libdir to $LIBNAME.
                            LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }-L$additional_libdir"
                          fi
                        fi
                        haveit=
                        for x in $LDFLAGS $LTLIB[]NAME; do
                          AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
                          if test "X$x" = "X-L$additional_libdir"; then
                            haveit=yes
                            break
                          fi
                        done
                        if test -z "$haveit"; then
                          if test -d "$additional_libdir"; then
                            dnl Really add $additional_libdir to $LTLIBNAME.
                            LTLIB[]NAME="${LTLIB[]NAME}${LTLIB[]NAME:+ }-L$additional_libdir"
                          fi
                        fi
                      fi
                    fi
                    ;;
                  -R*)
                    dir=`echo "X$dep" | sed -e 's/^X-R//'`
                    if test "$enable_rpath" != no; then
                      dnl Potentially add DIR to rpathdirs.
                      dnl The rpathdirs will be appended to $LIBNAME at the end.
                      haveit=
                      for x in $rpathdirs; do
                        if test "X$x" = "X$dir"; then
                          haveit=yes
                          break
                        fi
                      done
                      if test -z "$haveit"; then
                        rpathdirs="$rpathdirs $dir"
                      fi
                      dnl Potentially add DIR to ltrpathdirs.
                      dnl The ltrpathdirs will be appended to $LTLIBNAME at the end.
                      haveit=
                      for x in $ltrpathdirs; do
                        if test "X$x" = "X$dir"; then
                          haveit=yes
                          break
                        fi
                      done
                      if test -z "$haveit"; then
                        ltrpathdirs="$ltrpathdirs $dir"
                      fi
                    fi
                    ;;
                  -l*)
                    dnl Handle this in the next round.
                    names_next_round="$names_next_round "`echo "X$dep" | sed -e 's/^X-l//'`
                    ;;
                  *.la)
                    dnl Handle this in the next round. Throw away the .la's
                    dnl directory; it is already contained in a preceding -L
                    dnl option.
                    names_next_round="$names_next_round "`echo "X$dep" | sed -e 's,^X.*/,,' -e 's,^lib,,' -e 's,\.la$,,'`
                    ;;
                  *)
                    dnl Most likely an immediate library name.
                    LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$dep"
                    LTLIB[]NAME="${LTLIB[]NAME}${LTLIB[]NAME:+ }$dep"
                    ;;
                esac
              done
            fi
          else
            dnl Didn't find the library; assume it is in the system directories
            dnl known to the linker and runtime loader. (All the system
            dnl directories known to the linker should also be known to the
            dnl runtime loader, otherwise the system is severely misconfigured.)
            LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }-l$name"
            LTLIB[]NAME="${LTLIB[]NAME}${LTLIB[]NAME:+ }-l$name"
          fi
        fi
      fi
    done
  done
  if test "X$rpathdirs" != "X"; then
    if test -n "$hardcode_libdir_separator"; then
      dnl Weird platform: only the last -rpath option counts, the user must
      dnl pass all path elements in one option. We can arrange that for a
      dnl single library, but not when more than one $LIBNAMEs are used.
      alldirs=
      for found_dir in $rpathdirs; do
        alldirs="${alldirs}${alldirs:+$hardcode_libdir_separator}$found_dir"
      done
      dnl Note: hardcode_libdir_flag_spec uses $libdir and $wl.
      acl_save_libdir="$libdir"
      libdir="$alldirs"
      eval flag=\"$hardcode_libdir_flag_spec\"
      libdir="$acl_save_libdir"
      LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$flag"
    else
      dnl The -rpath options are cumulative.
      for found_dir in $rpathdirs; do
        acl_save_libdir="$libdir"
        libdir="$found_dir"
        eval flag=\"$hardcode_libdir_flag_spec\"
        libdir="$acl_save_libdir"
        LIB[]NAME="${LIB[]NAME}${LIB[]NAME:+ }$flag"
      done
    fi
  fi
  if test "X$ltrpathdirs" != "X"; then
    dnl When using libtool, the option that works for both libraries and
    dnl executables is -R. The -R options are cumulative.
    for found_dir in $ltrpathdirs; do
      LTLIB[]NAME="${LTLIB[]NAME}${LTLIB[]NAME:+ }-R$found_dir"
    done
  fi
])

dnl AC_LIB_APPENDTOVAR(VAR, CONTENTS) appends the elements of CONTENTS to VAR,
dnl unless already present in VAR.
dnl Works only for CPPFLAGS, not for LIB* variables because that sometimes
dnl contains two or three consecutive elements that belong together.
AC_DEFUN([AC_LIB_APPENDTOVAR],
[
  for element in [$2]; do
    haveit=
    for x in $[$1]; do
      AC_LIB_WITH_FINAL_PREFIX([eval x=\"$x\"])
      if test "X$x" = "X$element"; then
        haveit=yes
        break
      fi
    done
    if test -z "$haveit"; then
      [$1]="${[$1]}${[$1]:+ }$element"
    fi
  done
])

# lib-ld.m4 serial 1 (gettext-0.11)
dnl Copyright (C) 1996-2002 Free Software Foundation, Inc.
dnl This file is free software, distributed under the terms of the GNU
dnl General Public License.  As a special exception to the GNU General
dnl Public License, this file may be distributed as part of a program
dnl that contains a configuration script generated by Autoconf, under
dnl the same distribution terms as the rest of that program.

dnl Subroutines of libtool.m4,
dnl with replacements s/AC_/AC_LIB/ and s/lt_cv/acl_cv/ to avoid collision
dnl with libtool.m4.

dnl From libtool-1.4. Sets the variable with_gnu_ld to yes or no.
AC_DEFUN([AC_LIB_PROG_LD_GNU],
[AC_CACHE_CHECK([if the linker ($LD) is GNU ld], acl_cv_prog_gnu_ld,
[# I'd rather use --version here, but apparently some GNU ld's only accept -v.
if $LD -v 2>&1 </dev/null | egrep '(GNU|with BFD)' 1>&5; then
  acl_cv_prog_gnu_ld=yes
else
  acl_cv_prog_gnu_ld=no
fi])
with_gnu_ld=$acl_cv_prog_gnu_ld
])

dnl From libtool-1.4. Sets the variable LD.
AC_DEFUN([AC_LIB_PROG_LD],
[AC_ARG_WITH(gnu-ld,
[  --with-gnu-ld           assume the C compiler uses GNU ld [default=no]],
test "$withval" = no || with_gnu_ld=yes, with_gnu_ld=no)
AC_REQUIRE([AC_PROG_CC])dnl
AC_REQUIRE([AC_CANONICAL_HOST])dnl
ac_prog=ld
if test "$GCC" = yes; then
  # Check if gcc -print-prog-name=ld gives a path.
  AC_MSG_CHECKING([for ld used by GCC])
  case $host in
  *-*-mingw*)
    # gcc leaves a trailing carriage return which upsets mingw
    ac_prog=`($CC -print-prog-name=ld) 2>&5 | tr -d '\015'` ;;
  *)
    ac_prog=`($CC -print-prog-name=ld) 2>&5` ;;
  esac
  case $ac_prog in
    # Accept absolute paths.
    [[\\/]* | [A-Za-z]:[\\/]*)]
      [re_direlt='/[^/][^/]*/\.\./']
      # Canonicalize the path of ld
      ac_prog=`echo $ac_prog| sed 's%\\\\%/%g'`
      while echo $ac_prog | grep "$re_direlt" > /dev/null 2>&1; do
	ac_prog=`echo $ac_prog| sed "s%$re_direlt%/%"`
      done
      test -z "$LD" && LD="$ac_prog"
      ;;
  "")
    # If it fails, then pretend we aren't using GCC.
    ac_prog=ld
    ;;
  *)
    # If it is relative, then search for the first ld in PATH.
    with_gnu_ld=unknown
    ;;
  esac
elif test "$with_gnu_ld" = yes; then
  AC_MSG_CHECKING([for GNU ld])
else
  AC_MSG_CHECKING([for non-GNU ld])
fi
AC_CACHE_VAL(acl_cv_path_LD,
[if test -z "$LD"; then
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}${PATH_SEPARATOR-:}"
  for ac_dir in $PATH; do
    test -z "$ac_dir" && ac_dir=.
    if test -f "$ac_dir/$ac_prog" || test -f "$ac_dir/$ac_prog$ac_exeext"; then
      acl_cv_path_LD="$ac_dir/$ac_prog"
      # Check to see if the program is GNU ld.  I'd rather use --version,
      # but apparently some GNU ld's only accept -v.
      # Break only if it was the GNU/non-GNU ld that we prefer.
      if "$acl_cv_path_LD" -v 2>&1 < /dev/null | egrep '(GNU|with BFD)' > /dev/null; then
	test "$with_gnu_ld" != no && break
      else
	test "$with_gnu_ld" != yes && break
      fi
    fi
  done
  IFS="$ac_save_ifs"
else
  acl_cv_path_LD="$LD" # Let the user override the test with a path.
fi])
LD="$acl_cv_path_LD"
if test -n "$LD"; then
  AC_MSG_RESULT($LD)
else
  AC_MSG_RESULT(no)
fi
test -z "$LD" && AC_MSG_ERROR([no acceptable ld found in \$PATH])
AC_LIB_PROG_LD_GNU
])

dnl WMI_CONFIG_START
dnl
AC_DEFUN(WMI_CONFIG_START, [
AC_MSG_RESULT([
This is WMI2's configure script.
])
])

dnl WMI_CONFIG_END
dnl
AC_DEFUN(WMI_CONFIG_END, [
AC_MSG_RESULT([
------------------------------------------------------------------------
Configuration:

  Source code location:       $srcdir
dnl  Host System Type:           $host
  PHP version:                $phpversion
dnl  Webdir path:                $webdir
dnl  Install path:               $prefix
dnl  Install path:               $webdir/wmi
dnl  Locale path:                $localedir
dnl  Httpd user:                 $wwwuser
  Algebra system:             $algebrasystems
  Database name:              $dbname
  Database user:              $dbuser
  Database password:          $dbpasswd
  Database port:              $dbport
  Database hostname:          $dbhost

dnl See defaults.inc for further configuration information.
------------------------------------------------------------------------
])
AC_MSG_RESULT([
Configuration complete!
Your system seems to be ready to install WMI2.
])
])

dnl ---------------------------------------------------------------------

dnl WMI_PROG_WHICH
dnl
AC_DEFUN(WMI_PROG_WHICH,[dnl
AC_CHECK_PROG(WHICH,which,which,no)
if test "$WHICH" = no; then
        AC_MSG_ERROR([
'which' is required to run this configure script properly.
        ])
fi
])

dnl WMI_PROG_TIMEOUT
dnl
AC_DEFUN(WMI_PROG_TIMEOUT,[dnl
AC_CHECK_PROG(TIMEOUT,timeout,timeout,no)
if test "$TIMEOUT" = no; then
        AC_MSG_ERROR([
'timeout' is needed, install it first.
        ])
fi
])


dnl WMI_PROG_GETTEXT
dnl
AC_DEFUN(WMI_PROG_GETTEXT,[dnl
AC_CHECK_PROG(GETTEXT,gettext,gettext,no)
if test "$GETTEXT" = no; then
	AC_MSG_ERROR([
GNU gettext is needed, install it first.])
fi
])

dnl WMI_PROG_EUKLEIDES
dnl
AC_DEFUN(WMI_PROG_EUKLEIDES,[dnl
AC_CHECK_PROG(EUKLEIDES,eukleides,eukleides,no)
if test "$EUKLEIDES" = no; then
	AC_MSG_ERROR([
eukleides is needed for geometric illustrations, install it first.])
else
	eukleidesdir=`which eukleides`
	AC_SUBST(eukleidesdir)
fi
])

dnl WMI_PROG_POSTGRESQL
dnl
AC_DEFUN(WMI_PROG_POSTGRESQL,[dnl
AC_ARG_WITH(psqldir,
	AC_HELP_STRING([--with-psqldir=PATH],
		[the path to postgresql binaries]),
	psqldir=${withval})

if test "$psqldir"x = x; then
	AC_CHECK_PROG(POSTMASTER,postmaster,postmaster,no)
	psqldir=`which postmaster`
else
	AC_CHECK_PROG(POSTMASTER,postmaster,postmaster,no,$psqldir)
	psqldir="${psqldir}/postmaster"
fi

if test "$POSTMASTER" = no; then
	AC_MSG_ERROR([
PostgreSQL is needed, install it first.])
fi
AC_SUBST(psqldir)
])

dnl WMI_PROG_FORMCONV
dnl
AC_DEFUN(WMI_PROG_FORMCONV,[dnl
AC_ARG_WITH(formconvdir,
	AC_HELP_STRING([--with-formconvdir=PATH],
		[the path to formconv executable]),
	formconvdir=${withval})

if test "$formconvdir"x = x; then
	AC_CHECK_PROG(FORMCONV,formconv,formconv,no)
if test "$FORMCONV" = no; then
        AC_MSG_ERROR([
formconv is needed for parsing and converting math formulae, install it first.])
	fi
	formconvdir=`which formconv`
	fi
AC_SUBST(formconvdir)

AC_MSG_CHECKING(formconv's version)
formconvversion=`$formconvdir --version | head -n 1 | $AWK '{print @S|@4}'`
if test "$formconvversion" = ""; then
	formconvversion=`$formconvdir --version | head -2 | tail -1 | $AWK '{print @S|@3}'`
	fi

AC_MSG_RESULT($formconvversion)

formconvmajorver=`echo $formconvversion | $AWK -F . '{print @S|@1}'`
formconvminorver=`echo $formconvversion | $AWK -F . '{print @S|@2}'`
formconvrevver=`echo $formconvversion | $AWK -F . '{print @S|@3}'`

formconvreqmajor=0
formconvreqminor=8

if test $formconvmajorver -lt $formconvreqmajor || test $formconvmajorver -eq $formconvreqmajor -a $formconvminorver -lt $formconvreqminor; then
	AC_MSG_ERROR([
formconv version must be >= $formconvreqmajor.$formconvreqminor])
fi	
])


dnl WMI_BLOCK_AD
dnl
AC_DEFUN(WMI_BLOCK_AD,[
AC_ARG_ENABLE(ad,
        AC_HELP_STRING([--enable-ad],
                [enables advertisement system]),
        [
if test "x$enableval" = "xno"; then
 AD=FALSE
else
 AD=TRUE
fi
],[
 AD=FALSE
])
AC_SUBST(AD)
])

dnl WMI_BLOCK_WEKKER
dnl
AC_DEFUN(WMI_BLOCK_WEKKER,[
AC_ARG_ENABLE(wekker,
        AC_HELP_STRING([--enable-wekker],
                [enables the wekker database engine]),
        [
if test "x$enableval" = "xno"; then
 WEKKER=FALSE
else
 WEKKER=TRUE
fi
],[
 WEKKER=FALSE
])
AC_SUBST(WEKKER)
])

dnl WMI_PROG_PHP
dnl
AC_DEFUN(WMI_PROG_PHP,[dnl
AC_ARG_WITH(phpdir,
	AC_HELP_STRING([--with-phpdir=PATH],
		[the path to php binaries]),
	psqldir=${withval})
if test x$phpdir = x; then
	AC_CHECK_PROGS(PHP,[php php4 php5 php3],no)
	phpdir=`which $PHP`
else
	AC_CHECK_PROGS(PHP,[php php4 php5 php3],no,$phpdir)
	phpdir="${phpdir}/$PHP"
fi
if test "$PHP" = no; then
	AC_MSG_ERROR([
PHP is needed, install it first.])
else
	PHP=$phpdir
	phpversion=`$PHP -v | head -1`
	AC_SUBST(PHP)
	AC_SUBST(phpdir)
	AC_SUBST(phpversion)
fi
])

dnl WMI_PHPCHECK_GETTEXT
dnl
AC_DEFUN(WMI_PHPCHECK_GETTEXT,[
if test x$phpdir = x; then
	WMI_CHECK_PHP
fi
AC_MSG_CHECKING([gettext module for php])
if test `$PHP -m 2>&1 | grep -c gettext` = "0"; then
	AC_MSG_ERROR([
Gettext support for php is needed. Recompile php with --with-gettext.
See also the INSTALL file for more information.])
else
	AC_MSG_RESULT([ok])
fi
])

dnl WMI_PHPCHECK_PGSQL
dnl
AC_DEFUN(WMI_PHPCHECK_PGSQL,[
if test x$phpdir = x; then
	WMI_CHECK_PHP
fi
AC_MSG_CHECKING([pgsql module for php])
if test `$PHP -m 2>&1 | grep -c pgsql` = "0"; then
	AC_MSG_ERROR([
PostgreSQL support for php is needed. Recompile php with --with-pgsql.
See also the INSTALL file for more information.])
else
	AC_MSG_RESULT([ok])
fi
])

dnl WMI_PROG_CONVERT
dnl
AC_DEFUN(WMI_PROG_CONVERT,[
AC_CHECK_PROG(CONVERT,convert,convert,no)
if test "$CONVERT" = no; then
        AC_MSG_ERROR([
ImageMagick convert is needed for file conversions, install it first.])
else
        convertdir=`which convert`
        AC_SUBST(convertdir)
fi

AC_MSG_CHECKING(for ImageMagick's dvi delegate)
dnl @S|@ -> $
convertversion=`$convertdir --version | head -n 1 | $AWK '{print @S|@3}'`
convertmajorver=`echo $convertversion | $AWK -F . '{print @S|@1}'`

if test $convertmajorver -gt 4; then
	delegatecheck="convert -list Delegate"
else
	delegatecheck="convert --version"
fi

dvisupport=`$delegatecheck | grep -c dvi`

if test $dvisupport -gt 0; then
	AC_MSG_RESULT([ok])
else
	AC_MSG_RESULT([no])
	AC_MSG_ERROR([
No delegate for dvi, install e.g. dvips first.])
fi
])

dnl WMI_PROG_LYX
dnl
AC_DEFUN(WMI_PROG_LYX,[
AC_CHECK_PROG(LYX,lyx,lyx,no)
if test "$LYX" = no -a "$DOC" = true ; then
        AC_MSG_ERROR([
LyX is required for generating documentation, install it first.])
else
        lyxdir=`which lyx`
        AC_SUBST(lyxdir)
fi	
])

dnl WMI_PROG_LATEX2HTML
dnl
AC_DEFUN(WMI_PROG_LATEX2HTML,[
AC_CHECK_PROG(LATEX2HTML,latex2html,latex2html,no)
if test "$LATEX2HTML" = no; then
        AC_MSG_ERROR([
'latex2html' is required for generating documentation, install it first.])
else
        latex2htmldir=`which latex2html`
        AC_SUBST(latex2htmldir)
fi
])

dnl WMI_PROG_LATEX
dnl
AC_DEFUN(WMI_PROG_LATEX,[
AC_CHECK_PROG(LATEX,latex,latex,no)
AC_CHECK_PROG(TEX,tex,tex,no)

if test $LATEX = "no" -o $TEX = "no"; then
	AC_MSG_ERROR([
TeX/LaTeX is required for displaying math formulae, install it first.])
fi

latexdir=`which latex`
texdir=`which tex`
AC_SUBST(latexdir)
AC_SUBST(texdir)
])

dnl WMI_PROG_GNUPLOT
dnl
AC_DEFUN(WMI_PROG_GNUPLOT,[
AC_CHECK_PROG(GNUPLOT,gnuplot,gnuplot,no)
if test "$GNUPLOT" = no; then
        AC_MSG_ERROR([
gnuplot is required for graph plotting, install it first.])
else
        gnuplotdir=`which gnuplot`
        AC_SUBST(gnuplotdir)
fi

AC_MSG_CHECKING(gnuplot's version)
gnuplotversion=`$gnuplotdir --version 2>/dev/null | grep gnuplot | $AWK '{print @S|@2}'`

if test "$gnuplotversion" = ""; then
	AC_MSG_ERROR([
gnuplot does not support --version switch, it is too old for WMI; sorry])
fi

AC_MSG_RESULT($gnuplotversion)

gnuplotmajorver=`echo $gnuplotversion | $AWK -F . '{print @S|@1}'`
gnuplotminorver=`echo $gnuplotversion | $AWK -F . '{print substr(@S|@2,1,1)}'`
formconvrevver=`echo $gnuplotversion | $AWK -F . '{print substr(@S|@2,2)}'`

gnuplotreqmajor=3
gnuplotreqminor=8

if test $gnuplotmajorver -lt $gnuplotreqmajor || test $gnuplotmajorver -eq $gnuplotreqmajor -a $gnuplotminorver -lt $gnuplotreqminor; then
	AC_MSG_ERROR([
gnuplot version must be >= $gnuplotreqmajor.$gnuplotreqminor])
fi
])

dnl WMI_CHECK_DIRS(VARNAME, listofdirs (separated by whitespace), value if not found, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_DIRS,[dnl
AC_MSG_CHECKING($4)
$1=$3
for checkdir in $2; do
 	if test -d $checkdir; then
		$1=$checkdir
		break;
	fi
done
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_DIR(VARNAME, nameofdir, valueifnotfound, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_DIR,[dnl
$1=$3
AC_MSG_CHECKING($4)
if test -d $2; then
	$1=$2
fi
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_WEBDIR
dnl
AC_DEFUN(WMI_CHECK_WEBDIR,[
AC_ARG_WITH(webdir,
	AC_HELP_STRING([--with-webdir=PATH],
		[main installation directory for PHP scripts]),
	webdir=${withval})

if test "x$webdir" != "x"; then
	WMI_CHECK_DIR(WEBDIR_TMP, $webdir, no, [for web directory])
	if test $WEBDIR_TMP = "no"; then
		AC_MSG_ERROR([
Error looking for webdir ($webdir)... check if it's really an existing directory.])
	fi
else
	# /usr/local/httpd/	- SuSe 7.x and 8.0 Linux
	# /srv/www/htdocs/	- SuSe 8.2 Linux
	# /home/httpd/html	- Red Hat Linux < 9.0
	# /var/www		- Debian/GNU Linux, Red Hat Linux 9.0
	# /usr/local/www	- FreeBSD
	WMI_CHECK_DIRS(webdir,[/usr/local/httpd/htdocs /srv/www/htdocs /home/httpd/html	/var/www /usr/local/www], no, [for web directory])
        if test $webdir = "no"; then
                AC_MSG_ERROR([
no web directory defined, define it with "./configure --with-webdir=/foo/bar/" --- is Apache installed at all?])
        fi
fi
AC_SUBST(webdir)
])

dnl WMI_CHECK_USERS(VARNAME, listofusers (separated by whitespace), value if not found, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_USERS,[
$1=$3
AC_MSG_CHECKING($4)
for checkuser in $2; do
	if test `cat /etc/passwd | grep -c "${checkuser}:"` != "0"; then
		$1=$checkuser
		break
	fi
done
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_USER(VARNAME, nameofuser, valuifnotfound, checkmsg)
dnl
AC_DEFUN(WMI_CHECK_USER,[
$1=$3
AC_MSG_CHECKING($4)
if test `cat /etc/passwd | grep -c "$2:"` != "0"; then
	$1=$2
fi
AC_MSG_RESULT($$1)
])

dnl WMI_CHECK_DBNAME
dnl
AC_DEFUN(WMI_CHECK_DBNAME,[
AC_ARG_WITH(dbname,
        AC_HELP_STRING([--with-dbname=database_name],
                [the name of the database for querying]),
        dbname=${withval})

if test "x$dbname" = "x"; then
	dbname=wmi
fi
AC_SUBST(dbname)
])

dnl WMI_CHECK_DBUSER
dnl
AC_DEFUN(WMI_CHECK_DBUSER,[
AC_ARG_WITH(dbuser,
        AC_HELP_STRING([--with-dbuser=username],
                [the name of the user who queries the database]),
        dbuser=${withval})

if test "x$dbuser" = "x"; then
	dbuser=wmi
fi
AC_SUBST(dbuser)
])

dnl WMI_CHECK_DBPORT
dnl
AC_DEFUN(WMI_CHECK_DBPORT,[
AC_ARG_WITH(dbport,
        AC_HELP_STRING([--with-dbport=port],
                [the port number of the database]),
        dbport=${withval})

if test "x$dbport" = "x"; then
	dbport=5432
fi
AC_SUBST(dbport)
])

dnl WMI_CHECK_DBHOST
dnl
AC_DEFUN(WMI_CHECK_DBHOST,[
AC_ARG_WITH(dbhost,
        AC_HELP_STRING([--with-dbhost=host],
                [the hostname or IP number of the database server]),
        dbhost=${withval})

if test "x$dbhost" = "x"; then
	dbhost=localhost
fi
AC_SUBST(dbhost)
])

dnl WMI_CHECK_DBPASSWD
dnl
AC_DEFUN(WMI_CHECK_DBPASSWD,[
AC_ARG_WITH(dbpasswd,
        AC_HELP_STRING([--with-dbpasswd=password],
                [password for the user who queries the database]),
        dbpasswd=${withval})

AC_SUBST(dbpasswd)
])

dnl WMI_CHECK_WWWUSER
dnl
AC_DEFUN(WMI_CHECK_WWWUSER,[
AC_ARG_WITH(wwwuser,
        AC_HELP_STRING([--with-wwwuser=USER],
                [the name of the user who runs the httpd]),
        wwwuser=${withval})

if test "x$wwwuser" != "x"; then
	WMI_CHECK_USER(wwwusertmp,[$wwwuser],no,[for www user])
	if test $wwwusertmp = "no"; then
		AC_MSG_ERROR([
Invalid userhandle for www user ($wwwuser)])
	fi
else
	WMI_CHECK_USERS(wwwuser,[www-data wwwrun www apache],no,[for www user])
	if test $wwwuser = "no"; then
		AC_MSG_ERROR([
Error looking for a valid wwwuser... Please specify one with --with-wwwuser.])
	fi
fi
AC_SUBST(wwwuser)
])


dnl WMI_SET_LOCALEDIR
dnl
AC_DEFUN(WMI_SET_LOCALEDIR,[
AC_ARG_WITH(localedir,
        AC_HELP_STRING([--with-localedir=PATH],
                [path to locale's translation files (default: $webdir/wmi/locale/)]),
        localedir=${withval})

if test "x$localedir" = "x"; then
	if test "x$webdir" = "x"; then
		localedir="/usr/local/share/locale"
	else
		localedir="$webdir/wmi/locale"
	fi
fi

AC_SUBST(localedir)
])


dnl WMI_BLOCK_DOC
dnl
AC_DEFUN(WMI_BLOCK_DOC,[
AC_ARG_ENABLE(doc,
        AC_HELP_STRING([--disable-doc=yes],
                [disables autogenerating of the documentation]),
        [
if test "x$enableval" = "xno"; then
 DOC="#"
 echo Disabling creating documentation
else
 DOC=
fi
],[
 DOC=
])
AC_SUBST(DOC)
])

dnl WMI_ALGEBRA_CHECKMAXIMA
dnl
AC_DEFUN(WMI_ALGEBRA_CHECKMAXIMA,[dnl
maximadir=""
maximaleadinglines=0
AC_ARG_WITH(maximadir,
        AC_HELP_STRING([--with-maximadir=PATH],
                [path to maxima binaries]),
        maximadir=${withval})

if test "x$maximadir" = "x"; then
	AC_CHECK_PROG(MAXIMA,maxima,maxima,no)
	maximadir=`which maxima 2>/dev/null`
else
	AC_CHECK_PROG(MAXIMA,maxima,maxima,no,$maximadir)
	maximadir="${maximadir}/maxima"
fi

if test $MAXIMA = "no"; then
	maximaversion=""
	maximaleadinglines=0
else
	maximaversion=`$maximadir --version | cut -d " " -f2`
	if test "$maximaversion" = ""; then
	    maximaversion=`echo "quit();" | $maximadir | grep ^Maxima | awk '{print @S|@2}'`
	    AC_MSG_WARN([
Maxima version had to be detected via a non-standard way, because
"maxima --version" did not work. Please check if version string is correct.])
	    fi
	AC_MSG_RESULT([detected maxima version: $maximaversion])
	maximaversion=`config/v2n $maximaversion `
        echo "(internally will be used as $maximaversion)"
	maximaleadinglines=`echo "solve(x=5);" | $maximadir | nl -ba | grep "(D1)" | awk '{print (@S|@1)-1}'`
	if test "$maximaleadinglines" = ""; then
	    maximaleadinglines=`echo "solve(x=5);" | $maximadir | nl -ba | grep "(%o1)" | awk '{print (@S|@1)-1}'`
	    fi # For version 5.9.1 and above
	# Over 5.9.2 the maximaleadinglines should be incremented by 1:
	if test $maximaversion -gt 50902; then
	    maximaleadinglines=`expr $maximaleadinglines + 1`
	    fi
	    
	maximagclsupport=`echo "build_info();" | $maximadir | grep "lisp-implementation-version" | grep -c GCL`
	
	if test $maximagclsupport = 0; then
    		AC_MSG_WARN([
Maxima should be compiled with GCL to use it with WebMathematics Interactive.
In fact, WMI should work correctly with other Maxima/Lisp implementations,
however you may experience problems.])
#		maximadir=""
#		maximaversion=""
	fi
fi
AC_SUBST(maximadir)
AC_SUBST(maximaversion)
AC_SUBST(maximaleadinglines)
])

# dnl WMI_ALGEBRA_CHECKOCTAVE
# dnl
# AC_DEFUN(WMI_ALGEBRA_CHECKOCTAVE,[dnl
# octavedir=""
# AC_ARG_WITH(octavedir,
#         AC_HELP_STRING([--with-octavedir=PATH],
#                 [path to octave binaries]),
#         octavedir=${withval})
# 
# if test "x$octavedir" = "x"; then
# 	AC_CHECK_PROG(OCTAVE,octave,octave,no)
# 	octavedir=`which octave 2>/dev/null`
# else
# 	AC_CHECK_PROG(OCTAVE,octave,octave,no,octavedir)
# 	octavedir="${octavedir}/octave"
# fi
# 
# if test $OCTAVE = "no"; then
# 	octavedir=""
# fi
# AC_SUBST(octavedir)
# ])


dnl WMI_ALGEBRA_DETECT
dnl
AC_DEFUN(WMI_ALGEBRA_DETECT,[dnl

#AC_ARG_WITH(maxima,
#        AC_HELP_STRING([--with-maxima],
#                [use only maxima for computer algebra system]),
#        algebrasystem=maxima)
#AC_ARG_WITH(octave,
#        AC_HELP_STRING([--with-octave],
#                [use only octave for computer algebra system]),
#        algebrasystem=octave)

if test "x$algebrasystem" = "x"; then
	WMI_ALGEBRA_CHECKMAXIMA
	# WMI_ALGEBRA_CHECKOCTAVE

	if test mapeledir = "" -a mupaddir = "" && test maximadir = "" && test octavedir = "" ; then
		AC_MSG_ERROR([
At least one computer algebra system is required to install WebMathematics Interactive])
	fi
else
	case $algebrasystem in
	maxima)
		WMI_ALGEBRA_CHECKMAXIMA
                if test $maximadir = ""; then
                        AC_MSG_ERROR([
No maxima computer algebra system found...])
                fi
		mapledir=""
		mupaddir=""
		octavedir=""
 	;;
	octave)
		WMI_ALGEBRA_CHECKOCTAVE
                if test $octavedir = ""; then
                        AC_MSG_ERROR([
No octave computer algebra system found...])
                fi
		maximadir=""
 	;;
	esac
AC_SUBST(maximadir)
fi
])

dnl WMI_ALGEBRA_GETSYSTEMLIST(VARNAME)
dnl
AC_DEFUN(WMI_ALGEBRA_GETSYSTEMLIST,[
$1=""
if test "x$maximadir" != "x"; then $1="$$1,maxima"; fi
if test "x$octavedir" != "x"; then $1="$$1,octave"; fi
if test "x$$1" != "x"; then
	$1=`echo $$1 | $AWK '{printf("%s",substr(@S|@1,2))}'`
fi
])

