<TeXmacs|1.0.7.2>

<style|tmdoc>

<\body>
  <doc-data|<doc-title|A matek.hu portl>>

  <\abstract>
    Ez a dokumentci a <strong|matek.hu> oldalhoz kapcsold rvid, lnyegre
    tr lers.
  </abstract>

  <section|Mi a matek.hu?>

  A <strong|matek.hu> elssorban a 14--21 ves korosztlynak szmra
  ksztett matematika oktatsi portl. Elsdleges szerzi a <hlink|Szegedi
  Tudomnyegyetem|http://www.u-szeged.hu> <hlink|Bolyai
  Intzet|http://www.math.u-szeged.hu>nek munkatrsai.

  A portl legfontosabb clja az, hogy a matematika tanulsban segtsget
  nyjtson. A portl mgtt meghzd matematikai szoftverek a mai
  szmtgpes mdszerekkel elrhet legjobb matematikai szaktudst
  biztostjk. Nem minden esetben adnak helyes vagy teljes eredmnyt, de a
  legtbb gyakorlati krdst jl vlaszoljk meg. Emiatt a <strong|matek.hu>
  <emdash> mint brmi ms, hasonl rendszer <emdash> elssorban
  nellenrzsre, tletszerzsre, tovbb sok-sok rutinfeladat gyors
  megoldsra hasznlhat.

  A <strong|matek.hu> f clkitzse az, hogy egy olyan szimbolikus
  komputeralgebrai rendszer legyen, amelynek hasznlata magtl rtetd: ne
  legyen szksg programozi szaktudsra, csupn minimlis matematikai
  ismeretekre. Vilgos, hogy ez nmi kompromisszumot jelent a rendelkezsre
  ll feladattpusok tern. Azonban a szndkunk az, hogy a feladattpusok
  minl szlesebb krbl, a legfontosabb gyakorlati feladatok kzl
  kerljenek ki. Azok a felhasznlk, akik bonyolultabb, komplexebb
  feladatokat kvnnak megoldani, valsznleg hasznos, ha tovbblpnek
  professzionlis komputeralgebrai rendszerek fel. Ilyen tovbblps lehet
  az ingyenes, magyar nyelven is elrhet
  <hlink|wxMaxima|http://wxmaxima.sf.net> vagy a kereskedelmi forgalm, angol
  nyelven programozhat <em|<hlink|Mathematica|http://www.wolfram.com/products/student/mathforstudents>>.

  <section|Hogyan hasznlhat?>

  A <strong|matek.hu> hasznlathoz csupn egy (viszonylag korszer)
  webbngszre van szksg. Javaslatunk a <em|<hlink|Mozilla
  Firefox|http://firefox.hu> <em|2.0>>, de az <em|Internet Explorer> 6.0 s
  7.0 bngszk is teljes egszben tmogatottak.

  A <strong|matek.hu> portl kpernyjnek felptse alapveten kt rszre
  oszthat. Bal oldalon a program logja alatt lthat egy szmolgp,
  amelynek fels sorba bebillentyzhet a megoldani kvnt feladat, de
  ugyanezt csupn az egr gombjainak megnyomsval is megtehetjk. A bevitt
  kplet a jobb oldalon, a munkalapon azonnal megjelenik. A jobb oldal teht
  a kpernynek az a rsze, ahol a feladatok kpletei megjelennek, s
  ugyanitt lthatk ezen kpletek mint feladatok megoldsai is. A feladatokat
  pirossal, megoldsaikat kkkel lthatjuk.

  A bevitt feladatokat a szmolgp zldeskk szn nyomgombjaival oldhatjuk
  meg, melyek rendszerint a szmolgp jobb oldaln foglalnak helyet. A
  feladatok megoldsaira kattintva azok ismtelten bevihetk a szmolgpbe,
  s ezzel a megoldsokon jabb mveleteket vgezhetnk. A kpletek tmsolsa
  a mr bevitt feladatokon is mkdik.

  A bal oldalon tbbfle szmolgpet is kivlaszthatunk attl fggen, hogy
  milyen tpus feladatokat kvnunk megoldani. Az alaprtelmezett
  szmolgptpus a <em|kzpiskols>, amellyel egyenleteket oldhatunk meg,
  binomilis egytthatkat szmolhatunk, kt szm legnagyobb kzs osztjt
  hatrozhatjuk meg, szorzatt alakthatunk illetve kifejezseket
  rtkelhetnk ki. Tovbbi szmolgptpusokat a bal fels nyomgombbal
  vlaszthatunk.

  Akrcsak a bal fels nyomgomb, nhny ms gomb is almenket hoz el. Az
  ilyen tpus gombokat csoportgomboknak nevezzk. Egy csoportgomb fl menve
  az egrkurzorral, rvid idn bell megjelenik a krdses csoportgomb
  csoportja, vagyis nhny hozz hasonl gomb, amelyekkel hasonl funkcik
  hajthatk vgre. gy pldul az egyenletmegolds gombja fl menve
  lehetsg nylik fggvnyek brzolsra, a legnagyobb kzs oszt mellett
  pedig hasonl mdon megjelenik a legkisebb kzs tbbszrs gombja is. A
  szorzatt alakts csoportjban az sszegg alaktshoz is hozzfrhetnk.

  A jobb oldali munkalap aljn nhny ikon tallhat, amelyekkel j
  munkalapot indthatunk, illetve a munkalap tartalmt exportlhatjuk webes
  szvegfjlba. A munkalap nyomtatsra is lehetsg van.

  <subsection|6 fontos trkk>

  Igyekeztnk a portlt olyannyira felhasznlbartt tenni, amennyire csak
  lehetsges. Nhny hasznos tletet azrt mgis sszegyjtttnk itt, htha
  nem volna minden teljesen egyrtelm els pillantsra:

  <\itemize-dot>
    <item>A szorzs (<math|\<times\>>) jelt mindig ki kell rni, ha a
    szmolgp gombjaival visszk be a kpletet. Ha a billentyzetrl visszk
    be a formult, akkor a szorzs szoksos csillag (*) karaktere elhagyhat.

    <item>Egyenletek bersnl az egyenlsgjelet a szmolgp (ltalban)
    kzps rszn elhelyezett ``='' gombra kattintva lehet bevinni, ha
    egrrel dolgozunk.

    <item>Az <math|x<rsup|2>> egrrel trtn bevitelhez elszr az
    <math|x>, majd az <math|x<rsup|2>> gombot kell megnyomni. Billentyzetrl
    ugyanez az <verbatim|x^2> bevitelvel tehetjk meg <emdash> a
    <verbatim|^> (kalap) karakter bevitele az <kbd|AltGr 3> megnyomsval
    trtnik (Windows rendszeren a <verbatim|^> csak az azutn rt
    <verbatim|2>-es megnyomsa utn jelenik meg a <verbatim|2>-essel egytt).

    <item>A trt szmok bevitelhez tizedespontot (s nem a magyar
    szabvnynak megfelel tizedesvesszt) kell alkalmazni. A vessz gomb a
    bevinni kvnt kpletek elvlasztsra szolgl, ha tbb szmot vagy
    kifejezst szeretnnk megadni. Ilyen pldul kt vagy tbb szm
    legnagyobb kzs osztjnak meghatrozsa vagy tbb fggvny bevitele
    (fggvnybrzolshoz).

    <item>Tlsgosan szmolsignyes feladatoknl 10 msodperc utn a
    <strong|matek.hu> visszautastja a tovbbi szmolst a rendszer
    tlterhelsnek elkerlse rdekben.

    <item>Mtrixokat szgletes zrjelekkel s vesszvel kombinlva adhatunk
    meg. Pl. az egysgmtrix bevitele gy trtnik:
    [[1,0,0],[0,1,0],[0,0,1]]. Fontos: a mtrixszorzshoz a ``.'' (pont)
    karakterrel kell hasznlni.
  </itemize-dot>

  <section|Hogyan mkdik?>

  A <strong|matek.hu> portl a <hlink|WMI2|http://sf.net/projects/wmi>
  szoftveren alapul, amely egy <em|GNU/Linux> kiszolgln fut. A Linux
  kiszolgl <emdash> ahogyan sok ms hasonl szoftver <emdash> <em|Apache>
  webkiszolglt s <em|PostgreSQL> adatbziskezelt futtat. A WMI2 f
  rszeit <em|PHP> nyelven rtuk, melyek lland kommunikcit tartanak fenn
  a <hlink|<em|gnuplot>|http://www.gnuplot.info> fggvnybrzol s a
  <hlink|<em|Maxima>|http://maxima.sf.net> komputeralgebrai rendszerekkel,
  tovbb a <em|<hlink|TeX/LaTeX|http://hu.wikipedia.org/wiki/TeX>>
  matematikai szvegszed programokkal s az
  <hlink|<em|ImageMagick>|http://www.imagemagick.org> kpmanipulcis
  szoftverrel. A kpletkonverzikat a <hlink|<em|formconv>|http://formconv.sf.net>
  s a <em|<hlink|TeXmacs|http://www.texmacs.org>> szoftverekkel vgezzk. A
  WMI2 adatbzist a <em|Wekker> web 2.0-s alkalmazsgenertorral
  fejlesztettk. A hirdetsi rendszer mgtt a
  <hlink|MaxMind|http://maxmind.com> cg <em|GeoLiteCity> szoftvere ll.

  A programban igyekeztnk felhasznlni a legkorszerbb webtechnolgikat, s
  amit lehetett, nylt forrskd alapra helyeztnk. Tovbbi rszleteket
  errl a <verbatim|<hlink|<verbatim|http://sf.net/projects/wm>i|<verbatim|http://sf.net/projects/wm>i>>
  oldalon olvashat az rdekld felhasznl.

  <section|Szerzk s szerzi jog>

  A <strong|matek.hu> trtnete 2002-ig nylik vissza. Vajda Rbert s Kovcs
  Zoltn, a Szegedi Tudomnyegyetem Bolyai Intzetnek kt fiatal
  tanrsegdje ebben az vben kezdtek neki a WebMathematics Interactive
  webportl fejlesztsnek, amely lnyegben a <strong|matek.hu> elz
  vltozata volt. A program fejleszsbe szmos segt, munkatrs is
  bekapcsoldott. A fejlesztst 2006-tl a <hlink|Partci
  BT.|http://particio.com> szegedi cg vette t, melynek egyik f
  szakterlete matematikai szoftverek menedzselse.

  A <strong|matek.hu> portl mindenki szmra ingyenesen hasznlhat. A
  mgtte ll szoftverek legnagyobb rsze szabad szoftver, gy maga a WMI2
  is.

  A WMI2 s a WMI1 kztt sok hasonlsg van, de a 2-es vltozatot lnyegben
  az alapoktl jrartuk. Ennek a munknak a nagy rszt Fekete rpd
  kollgnk vgezte el, rszben szakdolgozati munkja keretben. A grafikai
  munkkrt ksznetet mondunk <hlink|Kovcs
  Zsigmond|http://kovzsi.szeged.hu>nak s <hlink|Dek
  Zsuzs|http://particio.com/zsuzsi>nak, tovbb a
  <hlink|Gnome|http://gnome.hu> asztali krnyezet grafikusainak. A 2.1-es
  kiads szmos funkcijnak kicsiszolsa Csernai Kornl bartunk rdeme.

  Hossz lenne felsorolni, kik is jrultak hozz akr kicsi, akr nagyobb
  rszben a program elkszlthez. Mgis megprblkozunk vele: hisszk, hogy
  minsgi szoftvert csak sszefogssal lehet kszteni. Ilyen kzs munka
  eredmnye a <strong|matek.hu> portl is.

  <subsection|Ksznet>

  A WMI2 elkszltben a legnagyobb rsze Chu-Ching Huangnak van, aki
  2006-ban lehetv tette <hlink|Kovcs Zoltn tajvani szakmai
  utazst|http://wmi.math.u-szeged.hu/~kovzol/Tajvan.php>, s sok-sok
  biztatssal, tmutatssal igyekezett az j verzi fel terelni bennnket.
  Sok segtsget kaptunk Bakos Gbortl az ltala rt <em|<em|formconv>>
  szoftver aprbb hibinak kiigaztshoz, tovbb Marti Miklstl, aki
  btortsval tlendtett bennnket a holtpontnak tn pillanatokon.

  Szegedi kollgink, Karsai Jnos, Szilassi Lajos, Makay Gza, Nmeth Zoltn
  s Nagy Gbor javaslatait is sokszor vettk fontolra. k mr a WMI1 ta
  hsges kritikusai s felhasznli rendszernknek. Ksznetet mondunk
  tovbb Srvri Csabnak s az  nevvel fmjelzett pcsi komputeralgebrai
  iskolnak, amely szmos lehetsget biztostott szmunkra a szakmai
  bemutatkozshoz s megmrettetshez.

  Ksznjk Joris van der Hoeven javaslatait a CAS rendszerekkel val
  sszekapcsolds tern. Sokat tanultunk az ltala rt TeXmacs rendszer
  technikai megvalstsaibl, hasonlkppen az
  <em|<hlink|Axiom|http://wiki.axiom-developer.org/FrontPage>> s a
  <hlink|<em|Sage>|http://www.sagemath.org> komputeralgebrai
  eltt-rendszerekbl is. Ezekben a szoftverekben sok szz matematikus s
  programoz hossz vekig tart munkja gykerezik.

  Lehetetlen felsorolni azokat a tovbbi, elssorban linuxos szakembereket,
  akik szakmai tmogatst vagy programozi szaktudst nyjtottak projektnk
  sorn. Csupn nhnyjukat emltjk meg: Tasndy-Szecs Zoltnt, Zana
  Rbertet, Ancsin Gbort, Bencs Jzsefet, Nagy Csabt, Hudi Istvnt, Lszl
  Tibort, Szcs Gbort s Kerekes Balzst. Nlklk nem jutottunk volna el
  oda, ahol most vagyunk.

  Vgezetl ksznetet mondunk a Consol Rendszerhz Kft.-nek, hogy a Wekker
  web 2.0 alap alkalmazsfejleszt eszkzt hozzfrhetv tettk a WMI2
  nyilvnos hasznlathoz.

  <subsection|Kapcsolat>

  Ezt a portlt a Partci BT. tartja karban. Elrhetsgnk:
  <hlink|<verbatim|http://www.particio.com>|<verbatim|http://www.particio.com>>.
  Elektronikus levlben az <verbatim|info@matek.hu> cmen vagyunk elrhetk,
  telefonon pedig a 70/622-6977-es szmon.
</body>

<\initial>
  <\collection>
    <associate|language|hungarian>
    <associate|page-screen-height|768000tmpt>
    <associate|page-screen-width|998400tmpt>
    <associate|sfactor|4>
  </collection>
</initial>