<?php

require_once '../includes/log.php';

// exec() wrappers with logging
// Unfortunately PHP4 does not support functions with default arguments
function execlog($cmd)
{

    global $safemode;

    if(!$safemode)
    {
    
	$cmd = escapeshellarg($cmd);
    
    }

    write_log("exec($cmd)", LOG_EXEC);
    return @exec($cmd);

}

function execlog2($cmd, &$output)
{

    global $safemode;

    if(!$safemode)
    {
    
	$cmd = escapeshellarg($cmd);
    
    }

    write_log("exec($cmd)", LOG_EXEC);
    return @exec($cmd, $output);

}


function execlog3($cmd, &$output, &$return_var)
{

    global $safemode;

    if(!$safemode)
    {
    
	$cmd = escapeshellarg($cmd);
    
    }

    write_log("exec($cmd)", LOG_EXEC);
    return @exec($cmd, $output, $return_var);

}

function execlog_debug_1($cmd)
{

    global $safemode;
/*
    if(!$safemode)
    {
    
	$cmd = escapeshellarg($cmd);
    
    }
*/
    write_log("exec($cmd)", LOG_EXEC);
    return @exec($cmd);

}

function execlog_debug($cmd, &$output)
{

    global $safemode;
/*
    if(!$safemode)
    {
    
	$cmd = escapeshellarg($cmd);
    
    }
*/
    write_log("exec($cmd)", LOG_EXEC);
    return @exec($cmd, $output);

}

function execlog_debug_2($cmd, &$output, &$return_var)
{

    global $safemode;
/*
    if(!$safemode)
    {
    
	$cmd = escapeshellarg($cmd);
    
    }
*/
    $ret = @exec($cmd, $output, $return_var);
    write_log("exec($cmd) = $return_var", LOG_EXEC);
    return $ret;

}


// unlink() wrapper with logging
function unlinklog($cmd)
{

    write_log("unlink($cmd)", LOG_UNLINK);
    $ret = @unlink($cmd);

    if(!$ret)
    {
	write_log("unlink($cmd) failed.", LOG_ERROR);
    }

    return $ret;

}

?>
