<?php
// Session related functions

require_once '../includes/config.php';

if ($adverts_on && !isset($_SESSION['geoip_latitude']))
{
    if (!isset($_SESSION['geoip_city']))
    {
	include("../wekker/php/geoip/geoipcity.inc");
	include("../wekker/php/geoip/geoipregionvars.php");
	$gi = geoip_open("../wekker/php/geoip/GeoLiteCity.dat", GEOIP_MEMORY_CACHE);
	$IP = $_SERVER['REMOTE_ADDR'];
	$record = geoip_record_by_addr($gi, $IP);
	$_SESSION['geoip_countryname'] = $record -> country_name;
	$_SESSION['geoip_city'] = $record -> city;
	$_SESSION['geoip_latitude'] = $record -> latitude;
	$_SESSION['geoip_longitude'] = $record -> longitude;
	geoip_close($gi);

	$_SESSION['geoip_city'] = iconv("ISO-8859-1", "UTF-8", $_SESSION['geoip_city']);

    }
}

// set new session and cookie values
if (!isset($_SESSION['lang']))
{
    if (isset($_COOKIE["language"]))
    {
        $_SESSION['lang'] = $_COOKIE["language"];
    }
    else
    {
        if ($_SESSION['geoip_countryname'] == "Hungary")
        {
	    $_SESSION['lang'] = "Hungarian";
	}
	else
	{
	    $_SESSION['lang'] = "English";
	}

	setcookie("language","English",time()+604800);
    }
}


if (!isset($_SESSION['calclayout']))
{
    if (isset($_COOKIE["layout"]))
    {
	$_SESSION['calclayout'] = $_COOKIE["layout"];

    }
    else
    {
	$_SESSION['calclayout'] = "normal";
	setcookie("layout", "normal", time() + 604800);
    }

}


// Uncomment this to reset cookies and session variables.
/*
$_SESSION['lang'] = "English";
setcookie("language", "English", time() + 604800);
$_SESSION['calclayout'] = "normal";
setcookie("layout", "normal", time() + 604800);
*/

?>
